/* Copyright (c) 1997, MpegTV LLC */
#ifndef _msg_h
#define _msg_h
#ifndef lint
static char rcsid_msg_h[] = "$Header: /home/tristan/mpeg/dec/RCS/msg.h,v 1.10 1997/08/11 05:16:56 tristan Exp $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "misc.h"
#include "exit.h"

/*--------------------------------------------------------------------------+
| Macros																	|
+--------------------------------------------------------------------------*/

#if 0 /* Tristan Savatier - Sat Aug 9 14:30:08 PDT 1997 */
//#define WARNING(printf_param)	STMT( \
//		if (Msg_select & MSG_WARNING) { \
//			printf("%s: %s:%d: warning: %s", Msg_progname, _msg_filename(__FILE__), __LINE__, (*Msg_info_func)()); \
//			printf printf_param; \
//			putchar('\n'); \
//		} \
//	)
#endif /* 0 - Tristan Savatier - Sat Aug 9 14:30:08 PDT 1997 */

#define WARNING(printf_param)	STMT( \
		if (Msg_select & MSG_WARNING) { \
			_msg_header("warning: ", __FILE__, __LINE__); \
			printf printf_param; \
			printf("\n"); \
		} \
	)


#if 0 /* Tristan Savatier - Sat Aug 9 14:45:34 PDT 1997 */
//#define MSG(type, message) STMT( \
//	if (Msg_select & (type)) { \
//		printf("%s: %s:%d: %s", Msg_progname, _msg_filename(__FILE__), __LINE__, (*Msg_info_func)()); \
//		printf message; \
//		putchar('\n'); \
//	} \
//)
#endif /* 0 - Tristan Savatier - Sat Aug 9 14:45:34 PDT 1997 */

#define MSG(type, message) STMT( \
	if (Msg_select & (type)) { \
		_msg_header("", __FILE__, __LINE__); \
		printf message; \
		printf("\n"); \
	} \
)

#if 0 /* Tristan Savatier - Sat Aug 9 14:46:13 PDT 1997 */
//#define MSG_ERROR(type, message) STMT( \
//	if (Msg_select & (type)) { \
//		int	_msg_errno = errno; \
//		printf("%s: %s:%d: %s", Msg_progname, _msg_filename(__FILE__), __LINE__, (*Msg_info_func)()); \
//		printf message; \
//		printf(": %s\n", strerror(_msg_errno)); \
//		errno = _msg_errno; \
//	} \
//)
#endif /* 0 - Tristan Savatier - Sat Aug 9 14:46:13 PDT 1997 */

#define MSG_ERROR(type, message) STMT( \
	if (Msg_select & (type)) { \
		int	_msg_errno = errno; \
		_msg_header("", __FILE__, __LINE__); \
		printf message; \
		printf(": %s\n", strerror(_msg_errno)); \
		errno = _msg_errno; \
	} \
)

#define MESSAGE(message) 	MSG(MSG_INFO, message)

#define MESSAGE_ERROR(message) 	MSG_ERROR(MSG_ERR, message)

#if 0 /* Tristan Savatier - Sat Aug 9 14:46:45 PDT 1997 */
//#define FATAL(printf_param)	STMT( \
//		printf("%s: %s:%d: error: %s", Msg_progname, _msg_filename(__FILE__), __LINE__, (*Msg_info_func)()); \
//		printf printf_param; \
//		putchar('\n'); \
//		EXIT(EXIT_FAILURE); \
//	)
#endif /* 0 - Tristan Savatier - Sat Aug 9 14:46:45 PDT 1997 */

#define FATAL(printf_param)	STMT( \
		_msg_header("error: ", __FILE__, __LINE__); \
		printf printf_param; \
		printf("\n"); \
		EXIT(EXIT_FAILURE); \
	)

#if 0 /* Tristan Savatier - Sat Aug 9 14:47:26 PDT 1997 */
//#define FATAL_ERROR(printf_param)	STMT( \
//		int	_msg_errno = errno; \
//		printf("%s: %s:%d: error: %s", Msg_progname, _msg_filename(__FILE__), __LINE__, (*Msg_info_func)()); \
//		printf printf_param; \
//		printf(": %s\n", strerror(_msg_errno)); \
//		EXIT(EXIT_FAILURE); \
//	)
#endif /* 0 - Tristan Savatier - Sat Aug 9 14:47:26 PDT 1997 */

#define FATAL_ERROR(printf_param)	STMT( \
		int	_msg_errno = errno; \
		_msg_header("error: ", __FILE__, __LINE__); \
		printf printf_param; \
		printf(": %s\n", strerror(_msg_errno)); \
		EXIT(EXIT_FAILURE); \
	)

/*--------------------------------------------------------------------------+
| Data types																|
+--------------------------------------------------------------------------*/

/* Masks used in Msg_select. Msg_select is a bitwise OR of those flags */

#define	MSG_INFO		(1 << 0)	/* for MESSAGE() */
#define	MSG_ERR			(1 << 1)	/* for ERROR() i.e. non-fatal errors */
#define	MSG_WARNING		(1 << 2)	/* for WARNING() */

/* the following are used to select specific messages frpm the player */
#define	MSG_SYNC		(1 << 3)	/* framerate sync messages */
#define	MSG_PTS			(1 << 4)	/* audio / PTS messages */
#define	MSG_PMP			(1 << 5)	/* process communication messages */
#define	MSG_READ		(1 << 6)	/* input stream read messages */
#define	MSG_SYS			(1 << 7)	/* systems parsing messages */
#define	MSG_X			(1 << 8)	/* Xlib */

#define	MSG_AUDIO_SYNC	(1 << 8)	/* audio sync */
#define	MSG_AUDIO_IOCTL	(1 << 9)	/* audio ioctl */
#define	MSG_AUDIO_WRITE	(1 << 10)	/* audio write samples */

/*--------------------------------------------------------------------------+
| Externals																	|
+--------------------------------------------------------------------------*/

extern u_long Msg_select;
extern const char *Msg_progname;

EXTERN_FUNCTION(const char * _msg_filename, (const char *));
EXTERN_FUNCTION(void _msg_header, (const char *, const char *, int));
#ifndef _msg_c
EXTERN_FUNCTION(const char * (*Msg_info_func), (void));
#endif


#endif /* _msg_h */
